//****************************************************************************
// Model: snake.qm
// File:  ./snake.cpp
//
// This code has been generated by QM tool (see state-machine.com/qm).
// DO NOT EDIT THIS FILE MANUALLY. All your changes will be lost.
//
// This program is open source software: you can redistribute it and/or
// modify it under the terms of the GNU General Public License as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//****************************************************************************
//${.::snake.cpp} ............................................................
#include "qpcpp.h"
#include "events.h"
#include "snake.h"
#include "bsp.h"
#include "draw.h"
#include <new> // placement new

Q_DEFINE_THIS_FILE

namespace blinky {

    enum {
        TICK_SIG = MAX_SIG,  // the last unique signal (see events.h)
    };

    
#if ((QP_VERSION < 580) || (QP_VERSION != ((QP_RELEASE^4294967295U) % 0x3E8)))
#error qpcpp version 5.8.0 or higher required
#endif

//${AOs::SnakeAO} ............................................................
class SnakeAO : public QP::QActive {
private:
    QP::QTimeEvt m_timeEvt;
    draw::Snake* m_snake;
    int8_t m_food_buf[sizeof(draw::Food)];
    draw::Food * m_food;
    int8_t m_snake_buf[sizeof(draw::Snake)];

public:
    uint16_t m_score;

public:
    SnakeAO();

private:
    bool eat_or_move();

protected:
    static QP::QState initial(SnakeAO * const me, QP::QEvt const * const e);
    static QP::QState Play(SnakeAO * const me, QP::QEvt const * const e);
    static QP::QState Right(SnakeAO * const me, QP::QEvt const * const e);
    static QP::QState Bottom(SnakeAO * const me, QP::QEvt const * const e);
    static QP::QState Top(SnakeAO * const me, QP::QEvt const * const e);
    static QP::QState Left(SnakeAO * const me, QP::QEvt const * const e);
    static QP::QState GameOver(SnakeAO * const me, QP::QEvt const * const e);
};


    // Local objects -------------------------------------------------------------
    static SnakeAO __self_ao; // the single instance active object

    // Global-scope objects ------------------------------------------------------
    QP::QActive * const AO_SnakePtr = &__self_ao; // "opaque" AO pointer

    //${AOs::SnakeAO} ............................................................
//${AOs::SnakeAO::SnakeAO} ...................................................
SnakeAO::SnakeAO()
  : QActive(Q_STATE_CAST(&SnakeAO::initial)),
    m_timeEvt(this, TICK_SIG, 0U)
{

    // body
}

//${AOs::SnakeAO::eat_or_move} ...............................................
bool SnakeAO::eat_or_move() {
    // return false if Game Over
    if( m_snake->can_eat(m_food->x, m_food->y) ) {
        m_snake->eat();
        m_food = new (m_food_buf) draw::Food;
        m_score++;
        return true;
    } else {
        return m_snake->move();
    }
}
//${AOs::SnakeAO::SM} ........................................................
QP::QState SnakeAO::initial(SnakeAO * const me, QP::QEvt const * const e) {
    // ${AOs::SnakeAO::SM::initial}
    me->m_timeEvt.armX(BSP::TICKS_PER_SEC/3, BSP::TICKS_PER_SEC/3);
    me->subscribe(BTNS_SIG);
    return Q_TRAN(&Right);
}
//${AOs::SnakeAO::SM::Play} ..................................................
QP::QState SnakeAO::Play(SnakeAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::SnakeAO::SM::Play}
        case Q_ENTRY_SIG: {
            me->m_snake = new (me->m_snake_buf) draw::Snake; // placement new
            me->m_food = new (me->m_food_buf) draw::Food;
            me->m_score = 0;
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::SnakeAO::SM::Play::TICK}
        case TICK_SIG: {
            // ${AOs::SnakeAO::SM::Play::TICK::[!me->eat_or_move()]}
            if (!me->eat_or_move()) {
                status_ = Q_TRAN(&GameOver);
            }
            else {
                status_ = Q_UNHANDLED();
            }
            break;
        }
        default: {
            status_ = Q_SUPER(&top);
            break;
        }
    }
    return status_;
}
//${AOs::SnakeAO::SM::Play::Right} ...........................................
QP::QState SnakeAO::Right(SnakeAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::SnakeAO::SM::Play::Right}
        case Q_ENTRY_SIG: {
            me->m_snake->set_direction(1, 0);
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::SnakeAO::SM::Play::Right::BTNS}
        case BTNS_SIG: {
            const auto button = Q_EVT_CAST(BtnEvt)->value;
            // ${AOs::SnakeAO::SM::Play::Right::BTNS::[top]}
            if (button == 0b1 || button == 0b1 << 4) {
                status_ = Q_TRAN(&Top);
            }
            // ${AOs::SnakeAO::SM::Play::Right::BTNS::[bottom]}
            else if (button == 0b10 || button == 0b10 << 4) {
                status_ = Q_TRAN(&Bottom);
            }
            else {
                status_ = Q_UNHANDLED();
            }
            break;
        }
        default: {
            status_ = Q_SUPER(&Play);
            break;
        }
    }
    return status_;
}
//${AOs::SnakeAO::SM::Play::Bottom} ..........................................
QP::QState SnakeAO::Bottom(SnakeAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::SnakeAO::SM::Play::Bottom}
        case Q_ENTRY_SIG: {
            me->m_snake->set_direction(0, 1);
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::SnakeAO::SM::Play::Bottom::BTNS}
        case BTNS_SIG: {
            const auto button = Q_EVT_CAST(BtnEvt)->value;
            // ${AOs::SnakeAO::SM::Play::Bottom::BTNS::[left]}
            if (button == 0b100 || button == 0b100 << 4) {
                status_ = Q_TRAN(&Left);
            }
            // ${AOs::SnakeAO::SM::Play::Bottom::BTNS::[right]}
            else if (button == 0b1000 || button == 0b1000 << 4) {
                status_ = Q_TRAN(&Right);
            }
            else {
                status_ = Q_UNHANDLED();
            }
            break;
        }
        default: {
            status_ = Q_SUPER(&Play);
            break;
        }
    }
    return status_;
}
//${AOs::SnakeAO::SM::Play::Top} .............................................
QP::QState SnakeAO::Top(SnakeAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::SnakeAO::SM::Play::Top}
        case Q_ENTRY_SIG: {
            me->m_snake->set_direction(0, -1);
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::SnakeAO::SM::Play::Top::BTNS}
        case BTNS_SIG: {
            const auto button = Q_EVT_CAST(BtnEvt)->value;
            // ${AOs::SnakeAO::SM::Play::Top::BTNS::[right]}
            if (button == 0b1000 || button == 0b1000 << 4) {
                status_ = Q_TRAN(&Right);
            }
            // ${AOs::SnakeAO::SM::Play::Top::BTNS::[left]}
            else if (button == 0b100 || button == 0b100 << 4) {
                status_ = Q_TRAN(&Left);
            }
            else {
                status_ = Q_UNHANDLED();
            }
            break;
        }
        default: {
            status_ = Q_SUPER(&Play);
            break;
        }
    }
    return status_;
}
//${AOs::SnakeAO::SM::Play::Left} ............................................
QP::QState SnakeAO::Left(SnakeAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::SnakeAO::SM::Play::Left}
        case Q_ENTRY_SIG: {
            me->m_snake->set_direction(-1, 0);
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::SnakeAO::SM::Play::Left::BTNS}
        case BTNS_SIG: {
            const auto button = Q_EVT_CAST(BtnEvt)->value;
            // ${AOs::SnakeAO::SM::Play::Left::BTNS::[top]}
            if (button == 0b1 || button == 0b1 << 4) {
                status_ = Q_TRAN(&Top);
            }
            // ${AOs::SnakeAO::SM::Play::Left::BTNS::[bottom]}
            else if (button == 0b10 || button == 0b10 << 4) {
                status_ = Q_TRAN(&Bottom);
            }
            else {
                status_ = Q_UNHANDLED();
            }
            break;
        }
        default: {
            status_ = Q_SUPER(&Play);
            break;
        }
    }
    return status_;
}
//${AOs::SnakeAO::SM::GameOver} ..............................................
QP::QState SnakeAO::GameOver(SnakeAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::SnakeAO::SM::GameOver}
        case Q_ENTRY_SIG: {
            draw::clr();
            draw::str(37, 2, "Game Over");
            draw::str_hex(5, "Score:", me->m_score);
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::SnakeAO::SM::GameOver}
        case Q_EXIT_SIG: {
            draw::clr();
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::SnakeAO::SM::GameOver::BTNS}
        case BTNS_SIG: {
            status_ = Q_TRAN(&Right);
            break;
        }
        default: {
            status_ = Q_SUPER(&top);
            break;
        }
    }
    return status_;
}


}

// define other elements...
